unit UMainForm;

// Plnn statistiky pro game-server

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Registry, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP, USqlDatabase, UAutoRegistry,
  ComCtrls;

type
  TMainForm = class(TForm)
    Timer1: TTimer;
    Button1: TButton;
    IdHTTP1: TIdHTTP;
    Button2: TButton;
    ListView1: TListView;
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    function GetCPUUsage: Real;
    { Private declarations }
  public
    started : boolean;
    reg : TRegistry;
    Database: TSqlDatabase;
    StatServerURL: string;
    DatabaseHostname: string;
    DatabaseUserName: string;
    DatabasePassword: string;
    DatabaseDatabase: string;
    //MangosFailure: string;
    AutoRegistry: TAutoRegistry;
  end;

const
  SystemBasicInformation = 0;
  SystemPerformanceInformation = 2;
  SystemTimeInformation = 3;

type
  TPDWord = ^DWORD;

  TSystem_Basic_Information = packed record
    dwUnknown1: DWORD;
    uKeMaximumIncrement: ULONG;
    uPageSize: ULONG;
    uMmNumberOfPhysicalPages: ULONG;
    uMmLowestPhysicalPage: ULONG;
    uMmHighestPhysicalPage: ULONG;
    uAllocationGranularity: ULONG;
    pLowestUserAddress: Pointer;
    pMmHighestUserAddress: Pointer;
    uKeActiveProcessors: ULONG;
    bKeNumberProcessors: byte;
    bUnknown2: byte;
    wUnknown3: word;
  end;

type
  TSystem_Performance_Information = packed record
    liIdleTime: LARGE_INTEGER; {LARGE_INTEGER}
    dwSpare: array[0..75] of DWORD;
  end;

type
  TSystem_Time_Information = packed record
    liKeBootTime: LARGE_INTEGER;
    liKeSystemTime: LARGE_INTEGER;
    liExpTimeZoneBias: LARGE_INTEGER;
    uCurrentTimeZoneId: ULONG;
    dwReserved: DWORD;
  end;

var
  NtQuerySystemInformation: function(infoClass: DWORD;
    buffer: Pointer;
    bufSize: DWORD;
    returnSize: TPDword): DWORD; stdcall = nil;


  liOldIdleTime: LARGE_INTEGER = ();
  liOldSystemTime: LARGE_INTEGER = ();

  MainForm: TMainForm;

implementation

uses UOptionsForm;

{$R *.dfm}


const
  // Sets UnixStartDate to TDateTime of 01/01/1970
  UnixStartDate: TDateTime = 25569.0;

function DateTimeToUnix(ConvDate: TDateTime): Longint;
begin
  //example: DateTimeToUnix(now);
  Result := Round((ConvDate - UnixStartDate) * 86400);
end;

function UnixToDateTime(USec: Longint): TDateTime;
begin
  //Example: UnixToDateTime(1003187418);
  Result := (Usec / 86400) + UnixStartDate;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
var
  Status : TMemoryStatus;
  UsedMemory: Cardinal;
  WebFile: TextFile;
  WoWUsers: string;
  CpuUsage: Real;
  WoWPlayers: Integer;
  DbRows: TDbRows;
  ListItem: TListItem;
  MangosRestartCount: Integer;
  DiskFreeSpace: Double;
  MangosNewAccountCount: Integer;
  I: Integer;
  Asc: TAssocArray;
begin
  with ListView1.Items do begin
    BeginUpdate;
    Clear;

    // Free memory
    Status.dwLength := SizeOf(TMemoryStatus);
    GlobalMemoryStatus(Status);
    ListItem := Add;
    ListItem.Caption := 'Celkem pamti';
    ListItem.SubItems.Add(IntToStr(Status.dwTotalPageFile div 1024 div 1024) + ' MB');
    UsedMemory := (Status.dwTotalPageFile - Status.dwAvailPageFile) div 1024 div 1024;
    ListItem := Add;
    ListItem.Caption := 'Pouit pamti';
    ListItem.SubItems.Add(IntToStr(UsedMemory) + ' MB');
    IdHTTP1.Get(StatServerURL + '?MeasureId=3&Value=' + IntToStr(UsedMemory));

    // CPU utilization
    CpuUsage := GetCpuUsage;
    ListItem := Add;
    ListItem.Caption := 'Zaten CPU';
    ListItem.SubItems.Add(FormatFloat('0.0 %', CpuUsage));
    IdHTTP1.Get(StatServerURL + '?MeasureId=4&Value=' + IntToStr(Round(CpuUsage)));

    // WoW players count
    Database.Database := DatabaseDatabase;
    DbRows := Database.Select('account', 'COUNT(*)', 'online=1');
    if DbRows.Count = 1 then begin
      WoWPlayers := StrToInt(DbRows[0].Values['COUNT(*)']);
    end;
    DbRows.Free;
    ListItem := Add;
    ListItem.Caption := 'Hr WoW';
    ListItem.SubItems.Add(IntToStr(WoWPlayers));
    IdHTTP1.Get(StatServerURL + '?MeasureId=5&Value=' + IntToStr(WoWPlayers));
//    ShowMessage(Database.LastErrorMessage);

    // Mangos new account count
    Database.Database := DatabaseDatabase;
    DbRows := Database.Select('account', 'COUNT(*)', 'joindate > (NOW() - INTERVAL 1 DAY)');
    if DbRows.Count = 1 then begin
      MangosNewAccountCount := StrToInt(DbRows[0].Values['COUNT(*)']);
    end;
    DbRows.Free;
    ListItem := Add;
    ListItem.Caption := 'Novch registrac WoW';
    ListItem.SubItems.Add(IntToStr(MangosNewAccountCount) + ' za den');
    IdHTTP1.Get(StatServerURL + '?MeasureId=8&Value=' + IntToStr(MangosNewAccountCount));

    // Mangos restarts count
    Database.Database := 'wow';
    DbRows := Database.Select('mangos_restart', 'COUNT(*)', 'time > (NOW() - INTERVAL 1 DAY)');
    if DbRows.Count = 1 then begin
      MangosRestartCount := StrToInt(DbRows[0].Values['COUNT(*)']);
    end;
    DbRows.Free;
    ListItem := Add;
    ListItem.Caption := 'Restarty MaNGOSu';
    ListItem.SubItems.Add(IntToStr(MangosRestartCount) + ' za den');
    IdHTTP1.Get(StatServerURL + '?MeasureId=6&Value=' + IntToStr(MangosRestartCount));

    // Harddisk free space
    DiskFreeSpace := Round(DiskFree(3) div 1024 div 1024 / 1024 * 1000) / 1000;
    ListItem := Add;
    ListItem.Caption := 'Voln msto na disku';
    ListItem.SubItems.Add(FloatToStr(DiskFreeSpace) + ' GB');
    IdHTTP1.Get(StatServerURL + '?MeasureId=7&Value=' + MySQLFloatToStr(DiskFreeSpace));

    EndUpdate;
  end;
end;

function Li2Double(x: LARGE_INTEGER): Double;
begin
  Result := x.HighPart * 4.294967296E9 + x.LowPart
end;

function TMainForm.GetCPUUsage: Real;
var
  SysBaseInfo: TSystem_Basic_Information;
  SysPerfInfo: TSystem_Performance_Information;
  SysTimeInfo: TSystem_Time_Information;
  status: Longint; {long}
  dbSystemTime: Double;
  dbIdleTime: Double;

  bLoopAborted : boolean;

begin
  if @NtQuerySystemInformation = nil then
    NtQuerySystemInformation := GetProcAddress(GetModuleHandle('ntdll.dll'),
      'NtQuerySystemInformation');

  // get number of processors in the system

  status := NtQuerySystemInformation(SystemBasicInformation, @SysBaseInfo, SizeOf(SysBaseInfo), nil);
  if status <> 0 then Exit;

(*
  // Show some information
  with SysBaseInfo do begin
      ShowMessage(
      Format('uKeMaximumIncrement: %d'#13'uPageSize: %d'#13+
      'uMmNumberOfPhysicalPages: %d'+#13+'uMmLowestPhysicalPage: %d'+#13+
      'uMmHighestPhysicalPage: %d'+#13+'uAllocationGranularity: %d'#13+
      'uKeActiveProcessors: %d'#13'bKeNumberProcessors: %d',
      [uKeMaximumIncrement, uPageSize, uMmNumberOfPhysicalPages,
      uMmLowestPhysicalPage, uMmHighestPhysicalPage, uAllocationGranularity,
      uKeActiveProcessors, bKeNumberProcessors]));
  end;
*)

  bLoopAborted := False;

//  while not bLoopAborted do
  begin

    // get new system time
    status := NtQuerySystemInformation(SystemTimeInformation, @SysTimeInfo, SizeOf(SysTimeInfo), 0);
    if status <> 0 then Exit;

    // get new CPU's idle time
    status := NtQuerySystemInformation(SystemPerformanceInformation, @SysPerfInfo, SizeOf(SysPerfInfo), nil);
    if status <> 0 then Exit;

    // if it's a first call - skip it
    if (liOldIdleTime.QuadPart <> 0) then begin

      // CurrentValue = NewValue - OldValue
      dbIdleTime := Li2Double(SysPerfInfo.liIdleTime) - Li2Double(liOldIdleTime);
      dbSystemTime := Li2Double(SysTimeInfo.liKeSystemTime) - Li2Double(liOldSystemTime);

      // CurrentCpuIdle = IdleTime / SystemTime
      dbIdleTime := dbIdleTime / dbSystemTime;

      // CurrentCpuUsage% = 100 - (CurrentCpuIdle * 100) / NumberOfProcessors
      dbIdleTime := 100.0 - dbIdleTime * 100.0 / SysBaseInfo.bKeNumberProcessors + 0.5;

      // Show Percentage
      Result := dbIdleTime;

      Application.ProcessMessages;

      // Abort if user pressed ESC or Application is terminated
      bLoopAborted := (GetKeyState(VK_ESCAPE) and 128 = 128) or Application.Terminated;

    end;

    // store new CPU's idle and system time
    liOldIdleTime := SysPerfInfo.liIdleTime;
    liOldSystemTime := SysTimeInfo.liKeSystemTime;

    // wait one second
    Sleep(100);
  end;
  if Result > 100 then Result := 100;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  Timer1Timer(nil);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  AutoRegistry := TAutoRegistry.Create('\Software\Chronosoft\ServerStat');
  with AutoRegistry do begin
    Include('StatServerUrl', StatServerUrl, 'http://localhost/game-server/statistic/add.php');
    Include('DatabaseDatabase', DatabaseDatabase, 'realmd');
    Include('DatabaseHostname', DatabaseHostname, 'localhost');
    Include('DatabaseUsername', DatabaseUsername, 'mangos');
    Include('DatabasePassword', DatabasePassword, 'mangos');
    //Include('MangosFailure', MangosFailure, 'c:\Mangos\Restarter\failure.txt');
    LoadFromRegistry;
  end;
  Database := TSqlDatabase.Create;
  with Database do begin
    Hostname := DatabaseHostname;
    Database := DatabaseDatabase;
    UserName := DatabaseUserName;
    Password := DatabasePassword;
    Connect;
  end;
  Timer1Timer(nil);
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  Timer1Timer(nil);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Database.Free;
  AutoRegistry.SaveToRegistry;
  AutoRegistry.Free;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  OptionsForm.ShowModal;
end;

end.
